#include FOXPRO.H

* Control characters.

#define ccNULL                  chr(0)
#define ccCR                    chr(13)

* Strings to substitute in error and other messages.

#define ccMSG_INSERT1           '<Insert1>'
#define ccMSG_INSERT2           '<Insert2>'
#define ccMSG_INSERT3           '<Insert3>'

* Messages

#define ccMSG_LOCATE            '<Insert1>:'

* VFP error numbers:

#define cnERR_TOO_FEW_ARGS         1229
	* too few arguments
#define cnERR_FILE_NOT_FOUND          1
	* file not found
#define cnERR_ALIAS_NOTFOUND 13
	* Alias is not found.
#define cnERR_ARRAYDIM       230
   * Bad array dimensions.
#define cnERR_RECINUSE                  109
#define cnERR_RECMODIFIED              1585
#define cnERR_DUPLKEY                  1884
#define cnERR_TRIGGER                  1539
#define cnERR_NONULLS                  1581
#define cnERR_FIELDRULE                1582
#define cnERR_TABLERULE                1583

* AERROR() array dimensions, including added extensions:

#define cnAERR_MAX              10
#define cnAERR_NUMBER        1
#define cnAERR_MESSAGE       2
#define cnAERR_OBJECT        3
#define cnAERR_WORKAREA      4
#define cnAERR_TRIGGER       5
#define cnAERR_EXTRA1        6
#define cnAERR_EXTRA2        7
#define cnAERR_METHOD           8
#define cnAERR_LINE             9
#define cnAERR_SOURCE           10

* Windows 95/NT Registry constants

#define cnSUCCESS              0
#define cnRESERVED             0
#define cnREG_SZ               1
	* the size of a data string
#define cnBUFFER_SIZE          256
	* the size of the buffer for the key value
#define cnHKEY_CLASSES_ROOT    -2147483648
#define cnHKEY_CURRENT_USER    -2147483647
#define cnHKEY_LOCAL_MACHINE   -2147483646
#define cnHKEY_USERS           -2147483645

* Common Dialog constants.

#define ccFILEDLG_OVERWRITE     0x2
#define ccFILEDLG_HIDERO        0x4
#define ccFILEDLG_SHOWHELP      0x10
#define ccFILEDLG_MULTIPLE      0x200
#define ccFILEDLG_PATHEXIST     0x800
#define ccFILEDLG_FILEEXIST     0x1000
#define ccFILEDLG_PROMPTNEW     0x2000

* Miscellaneous constants.

#define cnBUFFER_SIZE        2048
#define ccQST_DEBUG          'Display the debugger?'

* Application class constants.

#define cwWINDOW_PAD         Window
#define ccWINDOW_PAD         'Window'
	* the name of the Window pad

* Application class aForms array columns.

#define cnFORMS_ARRAY_COLS   7
#define cnFORMS_SCX_NAME     1
#define cnFORMS_OBJ_REF      2
#define cnFORMS_TOOLBAR_REF  3
#define cnFORMS_TOOLBAR_NAME 4
#define cnFORMS_ALLOW_MULT   5
#define cnFORMS_INSTANCE     6
#define cnFORMS_FORM_NAME    7

******************************
* Constants for the User class
******************************

* Login methods.

#define cnUSER_LOGIN_INI_FILE          1
	* login by looking in an INI file for the name of a DOS environment
	* variable, then using that variable to get the user name
#define cnUSER_LOGIN_WINDOWS           2
	* login by asking Windows for the user name
#define cnUSER_LOGIN_AUTO              3
	* automatic login: set the user name to "SUPERVISOR"

* Error messages.

#define ccMSG_USER_BAD_TABLE           'The user object does not have a properly defined user table.'
#define ccMSG_USER_USER_NOT_FOUND      '<Insert1> is not a valid user name.'
#define ccMSG_USER_NO_USER_SPECIFIED   'No user name was specified.'
